//////////////////////////////////////////////////////////////////////
#include "Common.ch"
#include "NLS.CH"
#include "DMLB.CH"
#include "FOXDBE.CH"
#include "Appbrow.ch"
#include "crypt.ch"

PROCEDURE Main
   LOCAL cKey, oKey, oCrypt1, oCrypt2, aStruct, n

   cKey :=  "A5:25:11:DA:1C:5C:72:9A:C9:78:03:FD:65:DF:0A:32"

   oKey := SecureKey():New()
   oKey:SetStrKey( cKey )

   oCrypt1 := CryptTable():New(,oKey)
   oCrypt2 := CryptTable():New(,oKey)
   oKey:Destroy()

   IF !File( "TEST1.DBF" )
      ERASE TEST1.FPT
      ERASE TEST1.CDX
      aStruct := oCrypt1:SetupStruct(;
                 {{"CODIGO",     "X",  5, 0},;
                  {"NOME",       "X", 40, 0},;
                  {"NASCIMENTO", "D",  8, 0},;
                  {"BLOQUEADO",  "L",  1, 0},;
                  {"DEBITO",     "F",  8, 0},;
                  {"CREDITO",    "F",  8, 0},;
                  {"DATAHORA",   "T",  8, 0},;
                  {"OBSERV",     "V", 10, 0}} )
      DbCreate( "TEST1", aStruct )
      USE TEST1 EXCLUSIVE
      oCrypt1:Enable()
      INDEX ON codigo      TAG NUM TO TEST1
      INDEX ON Upper(nome) TAG ALF TO TEST1
      CLOSE ALL
   ENDIF
   IF !File( "TEST2.DBF" )
      ERASE TEST2.CDX
      aStruct := oCrypt2:SetupStruct(;
                 {{"CODIGO",     "X",  5, 0},;
                  {"NOME",       "X", 40, 0}} )
      DbCreate( "TEST2", aStruct )
      USE TEST2 EXCLUSIVE
      oCrypt2:Enable()
      INDEX ON codigo      TAG NUM TO TEST2
      INDEX ON Upper(nome) TAG ALF TO TEST2
      CLOSE ALL
   ENDIF

   SELECT 1
   USE TEST1
   oCrypt1:Enable()
   SET INDEX TO TEST1
   IF !FLock()
      RETURN
   ENDIF

   SELECT 2
   USE TEST2
   oCrypt2:Enable()
   SET INDEX TO TEST2
   IF !FLock()
      RETURN
   ENDIF

   SELECT 1
   FOR n := 1 TO 10
      APPEND BLANK
      FIELD->CODIGO     := StrZ(Recno(),5)
      FIELD->NOME       := "JOO LUS"
      FIELD->NASCIMENTO := STOD("20000101")
      FIELD->DEBITO     := 10000000.12345
      FIELD->CREDITO    := 10000000.12345
      FIELD->DATAHORA   := "20151231101501"

      APPEND BLANK
      FIELD->CODIGO     := StrZ(Recno(),5)
      FIELD->NOME       := "ANTNIO JOS"
      FIELD->NASCIMENTO := STOD("19700101")
      FIELD->DEBITO     := 111111111.54321
      FIELD->CREDITO    := -100000000.54321
      FIELD->DATAHORA   := "18991231101501"
      FIELD->OBSERV     := "Credito concedido 100,000.00"
   NEXT

   SELECT 2
   FOR n := 1 TO 10
      APPEND BLANK
      FIELD->CODIGO     := StrZ(Recno(),5)
      FIELD->NOME       := "JOO LUS"

      APPEND BLANK
      FIELD->CODIGO     := StrZ(Recno(),5)
      FIELD->NOME       := "JOAO LUIS"
   NEXT

   SELECT 1
   GO TOP

   APPBROWSE;
      POSITION CENTER, CENTER;
      SIZE 60, 60 PERCENT
   APPDISPLAY

   SET ORDER TO TAG ALF
   GO TOP
   APPBROWSE;
      POSITION CENTER, CENTER;
      SIZE 60, 60 PERCENT
   APPDISPLAY

   SELECT 2
   GO TOP

   APPBROWSE;
      POSITION CENTER, CENTER;
      SIZE 60, 60 PERCENT
   APPDISPLAY

   SET ORDER TO TAG ALF
   GO TOP
   APPBROWSE;
      POSITION CENTER, CENTER;
      SIZE 60, 60 PERCENT
   APPDISPLAY

   CLOSE ALL
RETURN



PROCEDURE DbeSys()
   LOCAL cLocale := LocaleConfigure( LOCALE_TO_UPPER )
   LOCAL cLower  := ""
   LOCAL cUpper  := "AAAAAAAAEEEEEEIIIIOOOOOOOOUUUUCCUUIINN"
   LOCAL nCount  := Len( cLower )

   SET CHARSET   TO ANSI
   SET COLLATION TO ASCII
   FOR nChar := 1 TO nCount
      cLocale[ 1+Asc(cLower[nChar]) ] := cUpper[ nChar ]
   NEXT
   LocaleConfigure( LOCALE_TO_UPPER, cLocale )

   IF ! DbeLoad( "FOXDBE", .T.)
      Alert( "Database engine FOXDBE not loaded" , {"OK"} )
   ENDIF

   IF ! DbeLoad( "CDXDBE",.T.)
      Alert( "Database-Engine CDXDBE not loaded" , {"OK"} )
   ENDIF

   IF ! DbeBuild( "FOXCDX", "FOXDBE", "CDXDBE" )
      Alert( "FOXCDX Database-Engine;is not created" , {"OK"} )
   ENDIF

   DbeSetDefault( "FOXCDX" )
   DbeInfo( COMPONENT_DATA, DBE_EXTENSION,   "DBF" )
   DbeInfo( COMPONENT_DATA, FOXDBE_LIFETIME, 0 )

RETURN


FUNC StrZ( x, n )
   IF ValType( x ) == "C"
      RETURN StrTran( Str( Val( x ), n, 0 ), " ", "0" )
   ENDIF
RETURN StrTran( Str( x, n, 0 ), " ", "0" )
